
blocks:
    [x, y, z, w, h, d, rhz, rvt, r, g, b]

teleporters:
    [x, y, z, w, h, d, rhz, rvt, r, g, b, dest_chx, dest_chy]

entities: 
    [x, y, z, w, h, d, rhz, rvt, r, g, b, hp, damage, entityType ..]
    // Entity types are : 
    // 0 (coin) -> damage equals the coin's value
    // 1 (still explosive)
    // 2 (seeking explosive)
    // 3 (shooting still explosive)
    // if entityType = 4 (moving platform)
        [.. amplitude_x, amplitude_y, amplitude_z, mult, divd, phase] with
            amplitude_{x,y,z} = double[>= 0.0]
            {mult,divd} = int
            {phase} = int[0, 360]

    // else if entityType = 5 (linear moving platform)
        [.. amplitude_x, amplitude_y, amplitude_z, speed_x, speed_y, speed_z] with
        amplitude_{x,y,z} = double[>= 0.0]
        speed_{x,y,z} = double

    // else if entityType = 6 (text box)
        [.. text, tred, tgreen, tblue] with
            text = {char*}

    // else if entityType = 7 (warp text box)
        [.. dest_folder, room_count, text, tred, tgreen, tblue] with
            {dest_folder,text} = {char*} (length <= 50)
            {r,g,b} = int[0-256]


    // else if entityType = 8 (lock box)
        [.. cost, doPay, tred, tgreen, tblue] with
            cost = int[> 0] (0 breaks)
            doPay = {0, 1} (bool)

    else 
        [..]